<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarSupplier extends AbstractStructArrayBase
{
    /**
     * The RentacarSupplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarSupplier[]
     */
    public $RentacarSupplier;
    /**
     * Constructor method for ArrayOfJP_RentacarSupplier
     * @uses ArrayOfJP_RentacarSupplier::setRentacarSupplier()
     * @param \StructType\JP_RentacarSupplier[] $rentacarSupplier
     */
    public function __construct(array $rentacarSupplier = array())
    {
        $this
            ->setRentacarSupplier($rentacarSupplier);
    }
    /**
     * Get RentacarSupplier value
     * @return \StructType\JP_RentacarSupplier[]|null
     */
    public function getRentacarSupplier()
    {
        return $this->RentacarSupplier;
    }
    /**
     * Set RentacarSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarSupplier[] $rentacarSupplier
     * @return \ArrayType\ArrayOfJP_RentacarSupplier
     */
    public function setRentacarSupplier(array $rentacarSupplier = array())
    {
        foreach ($rentacarSupplier as $arrayOfJP_RentacarSupplierRentacarSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarSupplierRentacarSupplierItem instanceof \StructType\JP_RentacarSupplier) {
                throw new \InvalidArgumentException(sprintf('The RentacarSupplier property can only contain items of \StructType\JP_RentacarSupplier, "%s" given', is_object($arrayOfJP_RentacarSupplierRentacarSupplierItem) ? get_class($arrayOfJP_RentacarSupplierRentacarSupplierItem) : gettype($arrayOfJP_RentacarSupplierRentacarSupplierItem)), __LINE__);
            }
        }
        $this->RentacarSupplier = $rentacarSupplier;
        return $this;
    }
    /**
     * Add item to RentacarSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarSupplier $item
     * @return \ArrayType\ArrayOfJP_RentacarSupplier
     */
    public function addToRentacarSupplier(\StructType\JP_RentacarSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarSupplier) {
            throw new \InvalidArgumentException(sprintf('The RentacarSupplier property can only contain items of \StructType\JP_RentacarSupplier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RentacarSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarSupplier
     */
    public function getAttributeName()
    {
        return 'RentacarSupplier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RentacarSupplier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
